package com.youkeda.ykd_audio_recorder_example;


import android.content.pm.PackageManager;
import android.os.Build;
import android.os.Bundle;
import android.support.annotation.RequiresApi;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import com.youkeda.ykd_audio_recorder_example.mediarecorder.MediaRecorderr;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import io.flutter.app.FlutterActivity;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugins.GeneratedPluginRegistrant;
public class MainActivity extends FlutterActivity  {

        private static final String CHANNEL = "ykd_audio_recorder";
        MethodChannel methodChannel;


        //  声明一个集合，在后面的代码中用来存储用户拒绝授权的权
        private List<String> mPermissionList = new ArrayList<>();

    Map  map;
        private MediaRecorderr mediaRecorderr;
        @RequiresApi(api = Build.VERSION_CODES.N)
        @Override
        protected void onCreate(Bundle savedInstanceState) {
            super.onCreate(savedInstanceState);
            GeneratedPluginRegistrant.registerWith(this);

            initData();

            initChannel();

        }



        /**
         * 初始化数据
         */
        private void initData() {
            mediaRecorderr=new MediaRecorderr();
        }


        /**
         * 权限
         */
        private void setPermissions(String[] permissions, int permissionsCode) {
            mPermissionList.clear();
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
                for (String permission : permissions) {
                    if (ContextCompat.checkSelfPermission(this, permission) != PackageManager.PERMISSION_GRANTED) {
                        mPermissionList.add(permission);
                    }
                }

                //未授予的权限为空，表示都授予了
                if (mPermissionList.isEmpty()) {
                } else {
                    //将List转为数组
                    permissions = mPermissionList.toArray(new String[mPermissionList.size()]);
                    ActivityCompat.requestPermissions(this, permissions, permissionsCode);
                }
            }
        }
        @RequiresApi(api = Build.VERSION_CODES.N)
        private void initChannel() {
            Map<String, Object> startMap = new HashMap<>();
            this.methodChannel = new MethodChannel(getFlutterView(), CHANNEL);
            this.methodChannel.setMethodCallHandler(
                    (call, result) -> {
                        if (call.method.equals("start")) {
                            Object arguments = call.arguments;
                             map = (HashMap) arguments;

                            mediaRecorderr.startRecord(null);
                            startMap.put("success",true);
                            result.success(startMap);

                        } else if (call.method.equals("stop")) {
                            mediaRecorderr.stopRecord();
                            Map<String,Object> stringObjectMap=new HashMap<>();
                            if(map.isEmpty()){
                                stringObjectMap.put("path",mediaRecorderr.mFilePath);
                            }else{
                                stringObjectMap.put("path",map.get("path"));

                            }
                            Date date = new Date(mediaRecorderr.endTime-mediaRecorderr.startTime);
                            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
                            String startTime = sdf.format(date);

                            stringObjectMap.put("duration",mediaRecorderr.endTime-mediaRecorderr.startTime);
                            result.success(stringObjectMap);

                        } else if (call.method.equals("pause")) {

                            mediaRecorderr.pause();


                        } else if (call.method.equals("getVolumn")) {
                         double volumn=   mediaRecorderr.getVolumn();
                            result.success(volumn);
                        } else if (call.method.equals("resume")) {

                            mediaRecorderr.resume();
                        }

                    });
        }









}